net.dontdrinkandroot.wicket.bootstrap.component.button

## Class SubmitButtonLink<T>

- java.lang.Object
- - org.apache.wicket.Component
  - - org.apache.wicket.MarkupContainer
    - - org.apache.wicket.markup.html.WebMarkupContainer
      - - net.dontdrinkandroot.wicket.component.TypedWebMarkupContainer<T>
        - - net.dontdrinkandroot.wicket.bootstrap.component.button.AbstractButtonLink<T>
          - - net.dontdrinkandroot.wicket.bootstrap.component.button.AbstractSubmitButtonLink<T>
            - - net.dontdrinkandroot.wicket.bootstrap.component.button.SubmitButtonLink<T>

All Implemented Interfaces:
  Serializable, Iterable<org.apache.wicket.Component>, IButton, org.apache.wicket.event.IEventSink, org.apache.wicket.event.IEventSource, org.apache.wicket.IConverterLocator, org.apache.wicket.markup.html.form.IFormSubmitter, org.apache.wicket.markup.html.form.IFormSubmittingComponent, org.apache.wicket.markup.html.IHeaderContributor, org.apache.wicket.request.component.IRequestableComponent, org.apache.wicket.util.IHierarchical<org.apache.wicket.Component>, org.apache.wicket.util.io.IClusterable

    public class SubmitButtonLink<T>
    extends AbstractSubmitButtonLink<T>

See Also:
  Serialized Form

### Field Summary

### Fields inherited from class org.apache.wicket.Component

`ENABLE, FLAG_INITIALIZED, FLAG_REMOVING_FROM_HIERARCHY, FLAG_RESERVED1, FLAG_RESERVED2, FLAG_RESERVED3, FLAG_RESERVED4, FLAG_RESERVED5, FLAG_RESERVED8, PARENT_PATH, PATH_SEPARATOR, RENDER`

### Constructor Summary

Constructors
Constructor and Description
`SubmitButtonLink(String id)`
`SubmitButtonLink(String id, org.apache.wicket.markup.html.form.Form<?> form)`
`SubmitButtonLink(String id, org.apache.wicket.model.IModel<T> model)`
`SubmitButtonLink(String id, org.apache.wicket.model.IModel<T> model, org.apache.wicket.markup.html.form.Form<?> form)`
`SubmitButtonLink(String id, org.apache.wicket.model.IModel<T> model, org.apache.wicket.model.IModel<String> labelModel)`
`SubmitButtonLink(String id, org.apache.wicket.model.IModel<T> model, org.apache.wicket.model.IModel<String> labelModel, org.apache.wicket.markup.html.form.Form<?> form)`

### Method Summary

Methods
`protected String` `getTriggerJavaScript()` The JavaScript which triggers this link.
`void` `onAfterSubmit()` Override this method to provide special submit handling in a multi-button form.
`protected void` `onComponentTag(org.apache.wicket.markup.ComponentTag tag)`
`void` `onError()`
`void` `onLinkClicked()` This method is here as a means to fall back on normal link behavior when this link is not nested in a form.
`void` `onSubmit()` Override this method to provide special submit handling in a multi-button form.
`protected boolean` `shouldInvokeJavaScriptFormOnsubmit()` Controls whether or not clicking on this link will invoke form's javascript onsubmit handler.

### Methods inherited from class net.dontdrinkandroot.wicket.bootstrap.component.button.AbstractSubmitButtonLink

`getDefaultFormProcessing, getForm, getInputName, setDefaultFormProcessing`

### Methods inherited from class net.dontdrinkandroot.wicket.bootstrap.component.button.AbstractButtonLink

`disableLink, getButtonSize, getButtonSizeModel, getButtonStyle, getButtonStyleModel, isLinkEnabled, onComponentTagBody, onInitialize, setButtonSize, setButtonStyle, setLabelModel`

### Methods inherited from class net.dontdrinkandroot.wicket.component.TypedWebMarkupContainer

`getModel, getModelObject, setModel, setModelObject`

### Methods inherited from class org.apache.wicket.markup.html.WebMarkupContainer

`getWebPage, getWebRequest, getWebResponse, getWebSession`

### Methods inherited from class org.apache.wicket.MarkupContainer

`add, addOrReplace, autoAdd, contains, get, get, getAssociatedMarkup, getAssociatedMarkupStream, getMarkup, getMarkupType, internalAdd, internalInitialize, iterator, iterator, onAfterRenderChildren, onRender, remove, remove, removeAll, renderAll, renderAssociatedMarkup, renderNext, replace, setDefaultModel, size, swap, toString, toString, visitChildren, visitChildren, visitChildren, visitChildren`

### Methods inherited from class org.apache.wicket.Component

`add, addStateChange, afterRender, beforeRender, canCallListenerInterface, checkComponentTag, checkComponentTagAttribute, checkHierarchyChange, clearOriginalDestination, configure, continueToOriginalDestination, debug, detach, detachModel, detachModels, determineVisibility, error, exceptionMessage, fatal, findMarkupStream, findPage, findParent, findParentWithAssociatedMarkup, getAjaxRegionMarkupId, getApplication, getBehaviorById, getBehaviorId, getBehaviors, getBehaviors, getClassRelativePath, getConverter, getDefaultModel, getDefaultModelObject, getDefaultModelObjectAsString, getDefaultModelObjectAsString, getEscapeModelStrings, getFeedbackMessages, getFlag, getId, getInnermostModel, getInnermostModel, getLocale, getLocalizer, getMarkup, getMarkupAttributes, getMarkupId, getMarkupId, getMarkupIdFromMarkup, getMarkupIdImpl, getMarkupSourcingStrategy, getMetaData, getModelComparator, getOutputMarkupId, getOutputMarkupPlaceholderTag, getPage, getPageRelativePath, getParent, getPath, getRenderBodyOnly, getRequest, getRequestCycle, getRequestFlag, getResponse, getSession, getSizeInBytes, getStatelessHint, getString, getString, getString, getStyle, getVariation, hasBeenRendered, hasErrorMessage, hasFeedbackMessage, info, initModel, internalOnModelChanged, internalPrepareForRender, internalRenderComponent, isActionAuthorized, isAuto, isBehaviorAccepted, isEnableAllowed, isEnabled, isEnabledInHierarchy, isIgnoreAttributeModifier, isRenderAllowed, isStateless, isVersioned, isVisibilityAllowed, isVisible, isVisibleInHierarchy, markRendering, modelChanged, modelChanging, newMarkupSourcingStrategy, onAfterRender, onBeforeRender, onConfigure, onDetach, onEvent, onModelChanged, onModelChanging, onRemove, prepareForRender, redirectToInterceptPage, remove, remove, render, renderComponentTag, rendered, renderHead, renderHead, renderHead, renderPlaceholderTag, replaceComponentTagBody, replaceWith, sameInnermostModel, sameInnermostModel, send, setAuto, setDefaultModelObject, setEnabled, setEscapeModelStrings, setFlag, setIgnoreAttributeModifier, setMarkup, setMarkupId, setMarkupIdImpl, setMetaData, setOutputMarkupId, setOutputMarkupPlaceholderTag, setParent, setRenderBodyOnly, setRequestFlag, setResponsePage, setResponsePage, setResponsePage, setVersioned, setVisibilityAllowed, setVisible, success, urlFor, urlFor, urlFor, urlFor, urlFor, visitParents, visitParents, warn, wrap`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### SubmitButtonLink

    public SubmitButtonLink(String id)

#### SubmitButtonLink

    public SubmitButtonLink(String id,
                    org.apache.wicket.markup.html.form.Form<?> form)

#### SubmitButtonLink

    public SubmitButtonLink(String id,
                    org.apache.wicket.model.IModel<T> model)

#### SubmitButtonLink

    public SubmitButtonLink(String id,
                    org.apache.wicket.model.IModel<T> model,
                    org.apache.wicket.model.IModel<String> labelModel)

#### SubmitButtonLink

    public SubmitButtonLink(String id,
                    org.apache.wicket.model.IModel<T> model,
                    org.apache.wicket.markup.html.form.Form<?> form)

#### SubmitButtonLink

    public SubmitButtonLink(String id,
                    org.apache.wicket.model.IModel<T> model,
                    org.apache.wicket.model.IModel<String> labelModel,
                    org.apache.wicket.markup.html.form.Form<?> form)

### Method Detail

#### onLinkClicked

    public final void onLinkClicked()

This method is here as a means to fall back on normal link behavior when this link is not nested in a form. Not intended to be called by clients directly.

See Also:
  `ILinkListener.onLinkClicked()`

#### onComponentTag

    protected void onComponentTag(org.apache.wicket.markup.ComponentTag tag)

Overrides:
  `onComponentTag` in class `AbstractButtonLink<T>`
See Also:
  `Component.onComponentTag(org.apache.wicket.markup.ComponentTag)`

#### shouldInvokeJavaScriptFormOnsubmit

    protected boolean shouldInvokeJavaScriptFormOnsubmit()

Controls whether or not clicking on this link will invoke form's javascript onsubmit handler. True by default.

Returns:
  true if form's javascript onsubmit handler should be invoked, false otherwise

#### getTriggerJavaScript

    protected String getTriggerJavaScript()

The JavaScript which triggers this link. Method is non-final so that subclasses can decorate the provided script by wrapping their own JS around a call to super.getTriggerJavaScript().

Returns:
  The JavaScript to be executed when the link is clicked.

#### onError

    public void onError()

See Also:
  `IFormSubmitter.onError()`

#### onAfterSubmit

    public void onAfterSubmit()

Override this method to provide special submit handling in a multi-button form. This method will be called after the form's onSubmit method.

#### onSubmit

    public void onSubmit()

Override this method to provide special submit handling in a multi-button form. This method will be called before the form's onSubmit method.